head	1.20;
access;
symbols;
locks;
comment	@ * @;


1.20
date	2011.06.04.17.41.34;	author Average;	state Exp;
branches;
next	1.10;

1.10
date	2011.06.04.16.06.02;	author Average;	state Exp;
branches;
next	1.4;

1.4
date	2011.06.04.16.05.00;	author Average;	state Exp;
branches;
next	1.3;

1.3
date	2011.06.03.16.02.22;	author Average;	state Exp;
branches;
next	1.2;

1.2
date	2011.06.03.15.06.26;	author Average;	state Exp;
branches;
next	1.1;

1.1
date	2011.06.03.14.23.23;	author Average;	state Exp;
branches;
next	;


desc
@@


1.20
log
@ݒt@@CS()
@
text
@UNIT Render;

INTERFACE
{$H+}
USES
Classes,SysUtils,Math,VPUtils,RPDef;

CONST
    ConstLengthLimit=1e15;
    ConstLengthFar=1e30;
    ConstPlaneLimit=1e-10;
    ConstEpsilon=1e-3;
    MaxDepth=10;
    VacuumRefractiveIndex=1.0;

TYPE
    LightClass=CLASS
        pos:VectorRecord;
        power:SpectrumRecord;
        constructor Create(pos_:VectorRecord;power_:SpectrumRecord);
    END;

    IntersectionRecord=Record
        t:single;
        p,n:VectorRecord;
        Material:MaterialRecord;
    end;

    IntersectableClass=CLASS
        constructor Create;virtual;abstract;
        function Intersect(var isect:IntersectionRecord;
                           Ray:RayRecord):boolean;virtual;abstract;
    END;

    SphereClass=CLASS(IntersectableClass)
        center:VectorRecord;
        radius:single;
        Material:MaterialRecord;

        constructor Create(xr:TXMLReader);virtual;
        function Intersect(var isect:IntersectionRecord;
                           Ray:RayRecord):boolean;override;

    end;
    PlaneClass=CLASS(IntersectableClass)
        n:VectorRecord;
        d:single;
        Material:MaterialRecord;
        constructor Create(xr:TXMLReader);virtual;
        function Intersect(var isect:IntersectionRecord;
                           ray:RayRecord):boolean;override;
    end;

    CheckedPlaneClass=CLASS(PlaneClass)
        InvGridSize:single;
        Material2:MaterialRecord;
        constructor Create(xr:TXMLReader);virtual;
        function Intersect(var isect:IntersectionRecord;
                           ray:RayRecord):boolean;override;
    end;

    SceneClass=Class
        LightList,ObjList:TList;
        constructor Create;
        procedure AddObj(OB:IntersectableClass);
        procedure AddLight(Light:LightClass);
        function random_dir_over_hemisphere(n:VectorRecord):VectorRecord;
        function Trace(ray:RayRecord;Depth:integer):SpectrumRecord;
        function FindNearestIntersection(ray:RayRecord):IntersectionRecord;
        function lighting(p,n:VectorRecord;m:MaterialRecord):SpectrumRecord;
        function Visible(Org,Target:VectorRecord):boolean;
        FUNCTION DiffuseLighting(p,n,lightPos:VectorRecord;
                                 DiffuseColor,
                                 LightPower:SpectrumRecord):SpectrumRecord;
    end;

function CameraLookat(xr:TXMLReader):CameraRecord;

function CreateIntersect:IntersectionRecord;
function HitIntersect(isect:IntersectionRecord):boolean;

function CreateRay(o,d:VectorRecord):RayRecord;

function GetCameraRay(CM:CameraRecord;x,y:single):RayRecord;



IMPLEMENTATION

function CreateRay(o,d:VectorRecord):RayRecord;
begin
    result.org:=o;
    result.dir:=d;
end;


constructor LightClass.Create(pos_:VectorRecord;power_:SpectrumRecord);
begin
    pos:=pos_;
    power:=power_;
end;

function CreateIntersect:IntersectionRecord;
begin
    result.t:=ConstLengthFar;
end;

function HitIntersect(isect:IntersectionRecord):boolean;
begin
    result:=((isect.t<0) or (isect.t<ConstLengthLimit));
end;

constructor SphereClass.Create(xr:TXMLReader);
var
    zero:VectorRecord;
begin
    zero.x:=0;zero.y:=0;zero.z:=0;
    center:=xr.GetNodeVectorValue('center',zero);
    radius:=StrToFloat(xr.GetNodeValue('radius/x','0')) ;

    material.col:=xr.GetNodeSpectrumValue('material/spectrum',blackcolor);
    material.reflection:=StrToFloat(
            xr.getNodeValue('material/reflection/rate','0')
    );
    material.refraction:=StrToFloat(
            xr.getNodeValue('material/refraction/rate','0')
    );
    material.refractiveRate:=StrToFloat(
            xr.getNodeValue('material/refraction/index','1')
    );
    material.EmissionColor:=
        xr.GetNodeSpectrumValue('material/emission',BlackColor);
end;

function SphereClass.Intersect(var isect:IntersectionRecord;
                                Ray:RayRecord):boolean;
var
    o_c:VectorRecord;
    b,c,d,dR,t:single;
begin

    result:=FALSE;
    o_c:=VecSub(ray.org,center);
    b:=VecDot(ray.dir,o_c);
    c:=VecDot(o_c,o_c)-sqr(radius);
    d:=b*b-c;
    IF d>=0 then begin
        dR:=sqrt(d);
        t:=-b-dR;
        IF t<=ConstEpsilon then t:=-B+dR;
        IF ((t>ConstEpsilon) and (isect.t>t)) then begin
            isect.t:=t;
            isect.p:=VecAdd(ray.org,VecScale(ray.dir,t));
            isect.n:=VecNormalize(VecSub(isect.p,center) );
            isect.material:=material;
            result:=TRUE;
            exit;
        end;
    end;
end;

constructor PlaneClass.Create(xr:TXMLReader);
var
    zero:vectorRecord;
begin
    zero.x:=0;zero.y:=1;zero.z:=0;
    n:=xr.GetNodeVectorValue('Normal',zero);

    zero.x:=0;zero.y:=0;zero.z:=0;
    d:=-VecDot(xr.GetNodeVectorValue('position',zero),n);

    material.col:=xr.GetNodeSpectrumValue('material/spectrum',blackcolor);
    material.reflection:=StrToFloat(
            xr.getNodeValue('material/reflection/rate','0')
    );
    material.refraction:=StrToFloat(
            xr.getNodeValue('material/refraction/rate','0')
    );
    material.refractiveRate:=StrToFloat(
            xr.getNodeValue('material/refraction/index','1')
    );
    material.EmissionColor:=
        xr.GetNodeSpectrumValue('material/emission',BlackColor);
end;

function PlaneClass.Intersect(var isect:IntersectionRecord;ray:RayRecord):boolean;
var
    v,t:single;
begin
    result:=FALSE;
    v:=VecDot(n,ray.dir);
    IF abs(v)<ConstPlaneLimit then begin
        result:=false;
        exit;
    end;
    t:=-(VecDot(n,ray.org)+d)/v;
    if ((t>ConstEpsilon)and(isect.t>t)) then begin
        isect.t:=t;
        isect.p:=VecAdd(ray.org,VecScale(ray.dir,t));
        isect.n:=n;
        isect.material:=material;
        result:=TRUE;
        exit;
    end;
end;

constructor CheckedPlaneClass.Create(xr:TXMLReader);
begin
    inherited Create(xr);
    InvGridSize:=StrToFloat(xr.GetNodeValue('checked/size','1.5') );

    material2.col:=xr.GetNodeSpectrumValue('material2/spectrum',blackcolor);
    material2.reflection:=StrToFloat(
            xr.getNodeValue('material2/reflection/rate','0')
    );
    material2.refraction:=StrToFloat(
            xr.getNodeValue('material2/refraction/rate','0')
    );
    material2.refractiveRate:=StrToFloat(
            xr.getNodeValue('material2/refraction/index','1')
    );
    material2.EmissionColor:=
        xr.GetNodeSpectrumValue('material2/emission',BlackColor);

end;

function CheckedPlaneClass.Intersect(var isect:IntersectionRecord;
                                     ray:RayRecord):boolean;
var
    i:integer;
begin
    result:=false;
    if inherited Intersect(isect,ray) then begin
        result:=true;
        i:=floor(isect.p.x*InvGridSize)
          +floor(isect.p.y*InvGridSize)
          +floor(isect.p.z*InvGridSize);
        IF odd(i) then isect.material:=Material2;
    end;

end;


// J

  // _炠ʒu悤ɐݒs
function  CameraLookat(xr:TXMLReader):CameraRecord;
var
    CM:CameraRecord;
    imageplane,fov:single;
    zero,up,target,t_o,center:VectorRecord;
    width,height:integer;
begin
    width:=StrToInt(xr.GetValue('Screen/width','240'));
    height:=StrToInt(xr.GetValue('Screen/height','320'));
    xr.SetFirstNode('Sceen/Camera/');

    xr.SetFirstNode('Scene/Camera/');
    zero.x:=0;zero.y:=0;zero.z:=0;
    CM.eye := xr.GetNodeVectorValue('View',zero);

    fov:=DegToRad(StrToFloat(xr.GetNodeValue('Screen/radius','40') ) );
    imageplane := (height / 2) / tan(fov / 2);

    target:= xr.GetNodeVectorValue('Center',zero);
    t_o := VecNormalize(VecSub(target,CM.eye));

    up:=xr.GetNodeVectorValue('Vector',zero);
    CM.xaxis := VecNormalize(VecCross(t_o,up));
    CM.yaxis := VecCross(t_o,CM.xaxis);
    center := VecScale(t_o,imageplane);
    CM.origin := VecSub(
                    VecSub(center,VecScale(CM.xaxis,(0.5 * width)) ),
                    VecScale(CM.yaxis,(0.5 * height))
                 );
    result:=CM;
end;

function GetCameraRay(CM:CameraRecord;x,y:single):RayRecord;
var
    dir:VectorRecord;
begin
    dir:= VecNormalize(
                VecAdd(VecAdd(CM.origin,VecScale(CM.xaxis,x)),
                       (VecScale(CM.yaxis,y)))
          );
    result:=CreateRay(CM.eye, dir);
end;


constructor SceneClass.Create;
begin
    ObjList:=TList.Create;
    LightList:=TList.Create;
end;

procedure SceneClass.AddObj(OB:IntersectableClass);
begin
    ObjList.Add(OB);
end;

procedure SceneClass.AddLight(Light:LightClass);
begin
    LightList.Add(Light);
end;


// ̃_ȕ肷
function SceneClass.random_dir_over_hemisphere(n:VectorRecord):VectorRecord;
var
    x,y,z:single;
    ll:single;
begin
    while true do begin
        x:=(random(2000)-1000);x:=x/1000;
        y:=(random(2000)-1000);y:=y/1000;
        z:=(random(2000)-1000);z:=z/1000;
        ll:=x*x+y*y+z*z;
        if ((ll>0)and(ll<1.0)) THEN BEGIN
            ll:=Sqrt(ll);
            result.x:=x/ll;
            result.y:=y/ll;
            result.z:=z/ll;

            IF VecDot(result,n)<0 then result:=VecNeg(result);
            exit;
        END;
    end;
end;


function SceneClass.Trace(ray:RayRecord;Depth:integer):SpectrumRecord;
    // gU˖ʂ̔ˌvZ
    function TraceDiffuseReflection(p,n:VectorRecord;
                                    diffuse_color:SpectrumRecord;
                                    depth:integer):SpectrumRecord;
    var
        r:VectorRecord;
        Li,fr:SpectrumRecord;
        m:materialRecord;
        dot:single;
    begin
    // _̖@@ɑ΂āÃ_ȕɃC΂
        r:=random_dir_over_hemisphere(n);
        Li := trace( CreateRay(p, r), depth);
        fr := SpecScale(diffuse_color,1.0 / PI);
        dot := VecDot(n,r);
        result:=SpecScale( SpecMul(Li,fr),2 * PI * dot);
    end;
    function reflect(v, n:VectorRecord):VectorRecord;
    begin
        result:= VecSub(v,(VecScale(n,(2 * VecDot(v,n)))));
    end;
    function TraceReflection(p,n,v:VectorRecord;depth:integer):SpectrumRecord;
    var
        r:VectorRecord;
    begin
        r := reflect(v, n);
        result:=trace(CreateRay(p, r), depth);
    end;
    function refract(var isOK:boolean;v,n:VectorRecord;eta_i,eta_t:single):VectorRecord;
    var
       VdotN,eta,d:single;
       a,b:VectorRecord;
    begin
        isOK:=true;
        VdotN := VecDot(v,n);
        eta := eta_i / eta_t;
        d := 1.0 - sqr(eta) * (1.0 - sqr(VdotN));
        IF d>0 then begin
            a := VecSub(v,( VecScale(VecScale(n,VdotN),eta) ));
            b := VecScale(n,sqrt(d));
            result:=VecSub(a,b);
            exit;
        end;
        isOK:=FALSE;
    end;

    function TraceRefraction(p,n,v:VectorRecord;
                             eta_i,eta_t:single;
                             depth:integer):SpectrumRecord;
    var
        r:VectorRecord;
        isOk:boolean;
    begin
        r:=refract(isOK,v,n,eta_i,eta_t);
        IF isOK then
           // 
           result:=trace(CreateRay(p,r),depth)
        else
           // S
           result:=TraceReflection(p, n, v, depth);
    end;
    function interact_surface(raydir,p,n:VectorRecord;
                              m:MaterialRecord;
                              eta_i, eta_t:single;
                              depth:integer):SpectrumRecord;
    var
       ks,kt,kd:single;
       t:single;
       c:SpectrumRecord;
    begin
        ks := m.reflection;
        kt := m.refraction;
        kd := 1.0 - ks - kt;
    // [1] ʔˁE܁EgU˂̉exɉĂ̂̈I
        t := random(1000)/1000;
        IF t<ks then begin
            c:=TraceReflection(p,n,raydir,depth)  ;
            result:=SpecMul(c,m.col);
            exit;
        end;
        IF t<(ks+kt) then begin
            c := TraceRefraction(p, n, raydir, eta_i, eta_t, depth);
            result:=SpecMul(c,m.col);
            exit;
        end;
        result:=TraceDiffuseReflection(p, n, m.col, depth);
    end;
var
    isect:IntersectionRecord;
    m:MaterialRecord;
    L,c,Col:SpectrumRecord;
    ks,kd,kt:single;
    dot:single;
begin
    Depth:=Depth+1;
    IF Depth>MaxDepth then begin
        result:=BlackColor;
        exit;
    end;
    isect := FindNearestIntersection(ray);
    IF HitIntersect(isect)=FALSE then begin
        result:=SkyColor;
        exit;
    end;
    m:= isect.material;
    dot := VecDot(isect.n,ray.dir);
    if (dot < 0) THEN BEGIN  // ̂ɊO瓖
        col := interact_surface(ray.dir, isect.p, isect.n, m, VacuumRefractiveIndex, m.RefractiveRate, depth);
        result:=SpecAdd(col, SpecScale(m.EmissionColor,-dot));
        exit;
    end
    ELSE
        // ̂očs
        result:=interact_surface(ray.dir, isect.p, VecNeg(isect.n), m, m.RefractiveRate, VacuumRefractiveIndex, depth);

{*****
    m := isect.material;
    IF (isect.n.dot(ray.dir)<0) THEN BEGIN
        L:=Black;
        ks:= m.reflection;
        if (ks > 0) THEN BEGIN
           c := TraceReflection(isect.p, isect.n, ray.dir, depth);
           L := L.add(c.scale(ks).mul(m.col));
        END;
        kt := m.refraction;
        IF (kt>0) THEN BEGIN
            c:=TraceRefraction(isect.p,isect.n,Ray.dir,
                               VacuumRefractiveIndex,
                               m.RefractiveRate,
                               Depth);
            L:=L.add(c.scale(kt).mul(m.col));
        END;
        kd := 1- ks -kt ;
        if (kd > 0) THEN BEGIN
           c := lighting(isect.p, isect.n, isect.material);
           L := L.add(c.scale(kd));
        END;
        result:=L;
    END
    ELSE
        result:=TraceRefraction(isect.p, isect.n.neg, ray.dir,
                                m.RefractiveRate,
                                VacuumRefractiveIndex, depth);
****}
end;

function SceneClass.FindNearestIntersection(ray:RayRecord):IntersectionRecord;
var
    isect:IntersectionRecord;
    i:integer;
    OBJ:IntersectableClass;
begin
    isect := CreateIntersect;
    i:=0;
    while i<ObjList.count do begin
      OBJ:=IntersectableClass(ObjList[i]);
      obj.intersect(isect, ray);
      i:=i+1;
    end;
    result:=isect;
end;
function SceneClass.lighting(p,n:VectorRecord;m:MaterialRecord):SpectrumRecord;
var
    L,c:SpectrumRecord;
    Light:LightClass;
    i:integer;
begin
    L:=BlackColor;//SpectrumRecord.Create(0,0,0);
    i:=0;
    while i<LightList.count do begin
        Light:=LightClass(LightList[i]);
        c:=DiffuseLighting(p,n,Light.pos,m.col,Light.power);
        L:=SpecAdd(L,c);
        i:=i+1;
    end;
    result:=L;
end;
function SceneClass.Visible(Org,Target:VectorRecord):boolean;
var
    t_o:VectorRecord;
    ShadowRay:RayRecord;
    isect:IntersectionRecord;
    n:integer;
    obj:IntersectableClass;
begin
    t_o := VecSub(target,org);
    // [2] VhEC߂
    ShadowRay:=CreateRay(org, VecNormalize(t_o));
    isect := CreateIntersect;
    // [3] ܂ł̋̏ɂ
    isect.t := VecLen(t_o);
    n:=0;
    while n<ObjList.count do begin
      obj := IntersectableClass(objlist[n]);
      if (obj.intersect(isect, ShadowRay))  THEN BEGIN
          result:=FALSE;
          exit;
      END;
      n:=n+1;
    end;
    result:=TRUE;
end;

FUNCTION SceneClass.DiffuseLighting(p,n,lightPos:VectorRecord;
                         DiffuseColor,LightPower:SpectrumRecord):SpectrumRecord;
VAR
    l_p,l:VectorRecord;
    dot,r,factor:SINGLE;
BEGIN
    result:=BlackColor;
    l_p:=VecSub(LightPos,p);
    l:=VecNormalize(l_p);
    dot:=VecDot(n,l);
    IF dot>0 THEN BEGIN
        IF Visible(p,LightPos) THEN BEGIN
            r:=VecLen(l_p);
            factor:=dot / (4*PI*r*r);
            result:=SpecMul(SpecScale(LightPower,factor),DiffuseColor);
            exit;
        END;
    END;
END;




BEGIN
    Randomize;
END.

Traceŗp





$Log: render.pas $
Revision 1.10  2011/06/04 16:06:02  Average
IVer1.10

Revision 1.4  2011/06/04 16:05:00  Average
renderPlaneNXǂނ悤

Revision 1.3  2011/06/03 16:02:22  Average
x͕ʂݒt@@CŐ\

Revision 1.2  2011/06/03 15:06:26  Average
Ƃ肠ASphereݒt@@Cǂݍőn`

Revision 1.1  2011/06/03 14:23:23  Average
Initial revision

@


1.10
log
@IVer1.10
@
text
@d77 1
a83 3
function CameraLookat(eye_,target,up:VectorRecord;
                      fov:single;
                      width,height:integer):CameraRecord;
d119 2
a120 1
    radius:=StrToFloat(xr.GetNodeValue('radius/x','0'));
d247 1
a247 3
function  CameraLookat(eye_,target,up:VectorRecord;
                       fov:single;
                       width,height:integer):CameraRecord;
d250 13
a262 4
    imageplane:single;
    t_o,center:VectorRecord;
begin
    CM.eye := eye_;
d264 2
d267 2
d569 4
a572 1
$Log: RENDER.PAS $
@


1.4
log
@renderPlaneNXǂނ悤
@
text
@d560 3
@


1.3
log
@x͕ʂݒt@@CŐ\
@
text
@d69 1
a69 1
        function FindNearestIntersectionRecord(ray:RayRecord):IntersectionRecord;
d422 1
a422 1
    isect := FindNearestIntersectionRecord(ray);
d469 1
a469 1
function SceneClass.FindNearestIntersectionRecord(ray:RayRecord):IntersectionRecord;
d560 3
@


1.2
log
@Ƃ肠ASphereݒt@@Cǂݍőn`
@
text
@d49 1
a49 2
        constructor Create(p_,n_:VectorRecord;
                           Material_:MaterialRecord);virtual;
d57 1
a57 3
        constructor Create(p_,n_:VectorRecord;
                           GridSize:single;
                           Material_,Material2_:MaterialRecord);virtual;
d163 3
a165 2
constructor PlaneClass.Create(p_,n_:VectorRecord;
                              Material_:MaterialRecord);
d167 18
a184 3
    n := VecNormalize(n_);
    d := -VecDot(p_,n);
    Material:=Material_;
d208 18
a225 7
constructor CheckedPlaneClass.Create(p_,n_:VectorRecord;
                                     GridSize:single;
                                     Material_,Material2_:MaterialRecord);
begin
    inherited Create(p_,n_,Material_);
    InvGridSize:=1/GridSize;
    Material2:=Material2_;
d560 3
@


1.1
log
@Initial revision
@
text
@d40 1
a40 3
        constructor Create(center_:VectorRecord;
                           radius_:single;
                           Material_:MaterialRecord);virtual;
d118 19
a136 7
constructor SphereClass.Create(center_:VectorRecord;
                               radius_:single;
                               Material_:MaterialRecord);
begin
    center:=center_;
    radius:=radius_;
    material:=material_;
d535 4
a538 1
$Log: render.pas $
@
